/***************************************************************************
                          export_excel.cpp  -  description
                             -------------------
    begin                : Mon Nov 19 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
	Vorerst gehen wir davon aus, da die Daten bereits sortiert bergeben werden.
*/


#include <stdlib.h>
#include <export_csv.h>
#include <qfile.h>

ExportObj_CSV::ExportObj_CSV(QWidget *parent, const char *name=0)
{
	exportFilename = new QString("/tmp/SqlGuiExport.tmp");
	exportData=NULL;
	last = NULL;
}

void ExportObj_CSV::setFilename(const QString * filename)
{
	exportFilename->setLatin1( filename->latin1() );
}

void ExportObj_CSV::addData(int row, int col, const char * data, int dtype=0)
{
	
	cell_t * temp = new cell_t;
	temp->row = row;
	temp->col = col;
	char * datastring = new char[ strlen(data) +1 ];
  strcpy( datastring, data );
	temp->data = datastring;
	temp->next = NULL;
	
	if( exportData == NULL )
	{
		exportData = temp;
		last = exportData;
	}
	else
	{
	
		last->next = temp;
		last = last->next;
	
//		cell_t * temp2 = exportData;
//		while(temp2->next)
//		{
//			temp2 = temp2->next;
//		}
//		temp2->next = temp;
	}
	
}

void ExportObj_CSV::finish()
{

QString tmpname = *(exportFilename);
QFile file(tmpname);
file.open(IO_WriteOnly);

cell_t * temp = exportData;
int oldrow = 0;
int row = 0;

while(temp){
	row = temp->row;
	if (row > oldrow)
	{
		file.writeBlock( "\n", 1);
		oldrow = row;
	}
	file.writeBlock( temp->data, strlen( temp->data ) );
	file.writeBlock( ";", 1 );
	temp = temp->next;
}

file.close();
}
